.\"	$NetBSD: grfconfig.8,v 1.15 2008/04/30 13:11:02 martin Exp $
.\"
.\" Copyright (c) 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Ezra Story and Bernd Ernesti.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd October 7, 1994
.Dt GRFCONFIG 8 amiga
.Os
.Sh NAME
.Nm grfconfig
.Nd alter grf device screen mode definitions at run time
.Sh SYNOPSIS
.Nm
.Op Fl r
.Ar device
.Op Ar file
.Sh DESCRIPTION
.Nm
is used to change or view the screen mode definition list contained
in a grf device.  You may alter the console screen definition as well
as the definitions for the graphic screen.  The console will automatically
reinitialize itself to the new screen mode.
.Pp
The following flags and arguments are interpreted by
.Nm :
.Bl -tag -width indent
.It Fl r
Print out a raw listing of the mode definitions instead of the
pretty list normally shown.
.It Ar device
The grf device to manipulate.  This argument is required.
.It Ar file
The file which contains the mode definitions.  If this argument
is not specified,
.Nm
will print out of a list of the modes currently loaded into
the grf device.
.El
.Sh MODE DEFINITION FILE
The mode definitions are taken from a file which has lines of the format:
.Pp
num clk wid hi dep hbs hss hse ht vbs vss vse vt flags
.Pp
.Bl -tag -width indent
.It Ar num
The mode number or 'c' for the console mode.
.It Ar clk
The pixel clock in Hz.
.It Ar wid
The screen mode's width.
.It Ar hi
The screen mode's height.
.It Ar dep
The bitdepth of the mode. Use 4 for a text console mode.
.It Ar hbs hss hse ht
The horizontal timing parameters for the mode in pixel values.  All the
values are relative to the end of the horizontal blank (beginning of the
displayed area).
.It Ar vbs vss vse vt
The vertical timing parameters for the mode in line values.  All the
values are relative to the end of vertical blank (beginning of the displayed
area).
.It Ar flags
By default every mode uses negative horizontal and vertical sync pulses,
it is non-interlaced and does not use scandoubling.
.Pp
.Bl -tag -width sync-on-green -offset indent
.It default
Use the default flags: -hsync -vsync
.It doublescan
Doublescan mode
.It interlace
Interlace mode
.It +hsync
Positive horizontal sync pulses
.It -hsync
Negative horizontal sync pulses
.It +vsync
Positive vertical sync pulses
.It -vsync
Negative vertical sync pulses
.It sync-on-green
Composite sync on green
.El
.El
.Pp
.Bd -literal
 ------------------------------------------------------
 |                           ^                        |
 |                          vse                       |
 |      (0,0)                                         |
 |        *-----------------------------------        |
 |        |                  ^        ^      |        |
 |        |                 vbe       !      |        |
 |        |                           !      |        |
 |        |                           !      |        |
 |\*[Lt]-hse   |\*[Lt]-hbe                      !      |\*[Lt]-hbs   |      |      |
 |        |                           !      |   hss-\*[Gt]| hse-\*[Gt]| hbe-\*[Gt]|
 |        |                          hi      |        |      |      |
 |        |                           !      |        |
 |        |                           !      |        |
 |        |\*[Lt]============ wid =========+=====\*[Gt]|        |
 |        |                           !      |        |
 |        |                           !      |        |
 |        |                           !      |        |
 |        |                           v      |        |
 |        ------------------------------------        |
 |                           ^                        |
 |                          vbs                       |
 |                                                    |
 ------------------------------------------------------
                             ^
                            vss
                        - ------- -
                             ^
                            vse
                        - ------- -
                             ^
                            vbe
.Ed
.Sh SEE ALSO
.Xr console 4 ,
.Xr grfcl 4 ,
.Xr grfcv 4 ,
.Xr grfcv3d 4 ,
.Xr grfet 4 ,
.Xr grfrh 4 ,
.Xr grfrt 4 ,
.Xr grful 4 ,
.Xr iteconfig 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.0 .
.Pp
The mode definition file changed two times.
.Pp
In
.Nx 1.0
all horizontal values were videoclock cycle values instead of pixel values:
.Pp
 num clk      wid hi  dep hbs hss hse hbe ht  vbs vss vse vbe  vt
.br
 1   31000000 640 480  8   80  86  96 102 104 480 489 492  517  520
 2   31000000 640 480  8   80  86  96 102 104 240 244 246  258  260
 3   31000000 640 480  8   80  86  96 102 104 960 978 984 1034 1040
.Pp
In
.Nx 1.1
and
.Nx 1.2 :
.Pp
 num clk      wid hi  dep hbs hss hse hbe ht  vbs vss vse vbe  vt
.br
 1   31000000 640 480  8  640 688 768 816 832 480 489 492  517  520
 2   31000000 640 480  8  640 688 768 816 832 240 244 246  258  260
 3   31000000 640 480  8  640 688 768 816 832 960 978 984 1034 1040
.Pp
the vertical values were used to select the interlace or doublescan mode.
All vertical values were half the width for the interlace mode and twice
the width for the doublescan mode.
.Pp
Beginning with
.Nx 1.3 :
.Pp
 num clk      wid hi  dep hbs hss hse ht  vbs vss vse vt  flags
.br
 1   31000000 640 480  8  640 688 768 832 480 489 492 520 default
 2   31000000 640 480  8  640 688 768 832 480 489 492 520 interlace
 3   31000000 640 480  8  640 688 768 832 480 489 492 520 doublescan
 4   31000000 640 480  8  640 688 768 832 480 489 492 520 +hsync +vsync
.Pp
hbe and vbe are computed in the grf drivers.
.Sh BUGS
.Nm
can not set the modes for
.Pa /dev/grf1 ,
.Pa /dev/grf2
and
.Pa /dev/grf4
and it will not work for
.Pa /dev/grf0 .
